import numpy, cv2

pt = numpy.array([[0,0,0], [0,0,-1], [0,1,0], [1,0,0],\
                  [0,1,-1],[1,0,-1], [1,1,0], [1,1,-1]],float)
ll = [[0,1],[0,2],[0,3],[1,4],[1,5],[2,4],\
         [2,6],[3,5],[3,6],[4,7],[5,7],[6,7]]

def draw_cube(image, K, base, length, Rmat, tvec):
    #print base.shape, cubept[0:1,:].T.shape, tvec.shape 
    for l in ll:
        ipt1 = K.dot(length*Rmat.dot(pt[l[0]:l[0]+1,:].T+base)\
                    + tvec)
        ipt2 = K.dot(length*Rmat.dot(pt[l[1]:l[1]+1,:].T+base)\
                    + tvec)
        cv2.line(image, (ipt1[0]/ipt1[2], ipt1[1]/ipt1[2]),\
            (ipt2[0]/ipt2[2], ipt2[1]/ipt2[2]), (0,0,255), 3)

if __name__ == "__main__":

    focal, z0 = 1000.0, 500.0 # z0 must be greater than 100
    cube_orig = numpy.array([[-0.5,-0.5,0.5]],float).T

    ang = 0.0
    while 1:
        rot1, jac1 = cv2.Rodrigues(numpy.array([[0, ang, 0]], float))
        rot2, jac2 = cv2.Rodrigues(numpy.array([[0.4, 0, 0]], float))
        ang = ang + numpy.pi/100
        rot = rot2.dot(rot1)
        trans = numpy.array([[0,0,z0]], float).T

        K = numpy.array([[focal, 0.0, 320.0],\
                         [0.0, focal, 240.0],\
                         [0.0,   0.0,   1.0]], float)
        
        image = numpy.zeros((480,640,3), dtype=numpy.uint8)
        draw_cube(image, K, cube_orig, 100, rot, trans)

        cv2.imshow('Image', image)
        key = cv2.waitKey(10)
        if key == 0x1b:
            break
        elif key == ord('a'):
            focal = focal + 50
        elif key == ord('z'):
            focal = focal - 50
        elif key == ord('s'):
            z0 = z0 + 50
        elif key == ord('x'):
            z0 = z0 - 50
        print 'focal =', focal, '/ z0 =', z0

cv2.destroyAllWindows()

